#define BUFFER_SIZE 20 // actual size of the buffer for integer values: (numberOfValsToRead*6)+(numberOfValsToRead-1)
#include <Wire.h> //Include the Wire library pin 4+5 sind Standard-vordefiniert in dieser Library
#include <MMA_7455.h> //Include the MMA_7455 library

MMA_7455 mySensor = MMA_7455(); //Make an instance of MMA_7455

char incommingBuffer[BUFFER_SIZE]; // buffer to store incomming values
char incomming; // primary buffer to store single incommning bytes
int incommingCounter = 0; // counter for counting the positions inside the buffer


char xVal, yVal, zVal; //Variables for the values from the sensor
float prevXval, prevYval, prevZval;  // define smoothing values

int firstValue;

void setup()
{
  
 pinMode(3, OUTPUT); 
  
 Serial.begin(9600);
 // Set the sensitivity you want to use
 // 2 = 2g, 4 = 4g, 8 = 8g
 mySensor.initSensitivity(2);
 // Calibrate the Offset, that values correspond in
 // flat position to: xVal = -30, yVal = -20, zVal = +20
 // !!!Activate this after having the first values read out!!!
 mySensor.calibrateOffset(8, 24, 3);
}

void loop()
{
  
 readSerial(); // read the values available at the serial port
 
 analogWrite(3, firstValue);
  
  

 xVal = mySensor.readAxis('x'); //Read out the 'x' Axis
 yVal = mySensor.readAxis('y'); //Read out the 'y' Axis
 zVal = mySensor.readAxis('z'); //Read out the 'z' Axis

 xVal = (0.8*prevXval)+(0.2*xVal);  //smoothing values
 yVal = (0.8*prevYval)+(0.2*yVal);
 zVal = (0.8*prevZval)+(0.2*zVal);

 prevXval = xVal;
 prevYval = yVal;
 prevZval = zVal;

 Serial.print(xVal, DEC);
 Serial.print(",");
 Serial.print(yVal, DEC);
 Serial.print(",");
 Serial.print(zVal, DEC);
 Serial.print(",");
 Serial.println();


}


void readSerial()
{
  while(Serial.available())
  {
    incomming = Serial.read(); // read single incommning bytes
 
    if(incomming != '\r') //if no carriage return is received proceed in reading the serial port
    {
      incommingBuffer[incommingCounter++] = incomming; // go on the next position in the buffer
    }
    else //read until a carriage ('\r') is received
    {
      incommingBuffer[incommingCounter] = '\0'; // set the last byte to NULL to sign it for the string operators
 
      char *a = strtok(incommingBuffer, ",.;"); // split the string after delimiters into tokens
      char *b = strtok(NULL, ",.;"); // ...
      char *c = strtok(NULL, ",.;"); // ...
      //char *d = strtok(NULL, ",.;"); // add another line if needed
 
      firstValue = atoi(a); // convert the strings into integers
      /* secondValue = atoi(b); // ...
      thirdValue = atoi(c); // ...
      //fourthValue = atoi(d); // add another line if needed    
      */
      
      incommingCounter = 0; // reset the counter
      memset(incommingBuffer, 0, BUFFER_SIZE); //overwrite the incommingBuffer
    }
  }
}
